<template>
  <single-pane>
    <ob-table
        :columns="columns"
        :sub-columns="subColumns"
        :functionalPanel="hasData"
        :remote-opt="{
          method: getData
        }"
        :sub-remote-opt="{
          method: getLocationsData
        }"
        :loading="loading"
        :show-add-button="true"
        add-button-text="Добавить агломерацию"
        is-sub-table-action
        :sub-table-action="subTableAction"
        toggle-sub-table-by-click-at-whole-row
        @subTableAction="onSubTableAction"
        is-fixed-header
        :tableLayoutFixed="false"
        :is-functional-filter="false"
        :is-functional-group="false"
        :is-functional-sort="false"
        :isSmartPagination="false"
        @add="addNewAglomeration"
        ref="agglomerationsTable"
    >
      <template v-slot:nameCol="{ data }">
        <div class="sub-table-header__title">
          <i class="icon aglomeration" />
          {{ data.item.title }}
        </div>
      </template>

      <template v-slot:updatedAt="{ data }">
        {{ data.item.updatedAt | date('DD.MM.YYYY, HH:mm') }}
      </template>

      <template v-slot:author="{ data }">
        {{ formatAuthor(data.item.author) }}
      </template>

      <template v-slot:locationCount="{ data }">
        Локаций: {{ data.item.locationCount || 0 }}
      </template>

      <template v-slot:editSlot="{ data }">
          <i @click.stop
             class="icon edit icon-btn"
             title="Редактировать"
             @click="onSelection(data.item)"
          />
      </template>

      <template v-slot:deleteSlot="{ data }">
        <div class="delete-col">
          <i @click.stop
             class="icon close icon-btn"
             title="Удалить"
             @click="deleteAgglomeration(data)"
          />
        </div>
      </template>


      <template v-slot:subNameCol="{ data }">
        <div class="sub-table-name">
          <i :class="locationIcon(data.item)" />
          {{ data.item.title }}
        </div>
      </template>

      <template v-slot:subDeleteCol="{ data }">
        <div class="delete-col" v-if="data.item._allowDelete">
          <i @click.stop
             class="icon close icon-btn"
             title="Удалить"
             @click="deleteLocation(data.item)"
          />
        </div>
      </template>

      <template slot="noneContent">
        <div class="title">
          Здесь вы сможете настраивать агломерации (группы локаций) для<br/>
          контейнерных перевозок. Для этого добавьте хотя бы одну агломерацию.
        </div>
        <ObButton
            label="Добавить агломерацию"
            type="flat"
            data-qa="addNewAglomeration"
            @click="addNewAglomeration"
        />
      </template>
    </ob-table>

    <ob-modal
        ref="raylwayAgglomerationModal"
        title="Агломерация"
        size="medium"
        :is-show-controls="false"
    >
      <raylway-agglomeration-modal
          :agglomeration="agglomerationForModal"
          @submitted="onSubmitModal"
          @close="closeModal"
      />
    </ob-modal>

    <ob-modal
        ref="deleteLocationModal"
        title="Удалить локацию"
        size="medium"
        :is-show-controls="true"
        ok-text="Удалить"
        @submit="deleteLocation2"
    >
      <div class="modal-content">
        Локация: <i :class="locationIcon(locationForDelete)"/> {{ locationForDelete ? locationForDelete.title : '' }}
      </div>
    </ob-modal>

    <ob-modal
        ref="deleteRaylwayAgglomerationModal"
        size="medium"
        :is-show-controls="true"
        ok-text="Удалить"
        @submit="deleteAgglomeration2"
    >
      <template slot="title">
        <div class="ob-ty-modal-title">
          Удалить агломерацию
        </div>
      </template>

      <div class="modal-content">
        Наименование: {{ agglomerationForDelete ? agglomerationForDelete.title : '' }} <br/>
        Локаций: {{ agglomerationForDelete ? agglomerationForDelete.locationCount || 0 : '' }}
      </div>
    </ob-modal>
  </single-pane>
</template>

<script>
/* eslint-disable */
import api from '@/api';
import { sortArray } from 'common-components/src/helpers/common'
import SinglePane from 'common-components/src/obComponents/obSinglePanels';
import ObTable from 'common-components/src/obComponents/obTable';
import ObButton from 'common-components/src/obComponents/obButton';
import ObModal from 'common-components/src/obComponents/obModal';
import raylwayAgglomerationModal from './raylwayAgglomerationModal'

export default {
  name: "raylwayAgglomeration",
  components: {
    SinglePane,
    ObTable,
    ObButton,
    ObModal,
    raylwayAgglomerationModal
  },

  data() {
    return {
      loading: true,
      hasData: false,
      subTableAction: {
        index: 1,
        icon: 'edit',
        text: 'Редактировать список'
      },
      agglomerationForModal: null,
      agglomerationForDelete: null,
      locationForDelete: null,
    }
  },

  computed: {
    columns() {
      return [
        {
          title: 'Наименование',
          key: 'title',
          slotName: 'nameCol'
        },
        {
          title: 'Последние изменения',
          key: 'updatedAt',
          slotName: 'updatedAt',
          width: 120
        },
        {
          title: 'Автор',
          key: 'author',
          slotName: 'author'
        },
        {
          title: '',
          key: 'locationCount',
          slotName: 'locationCount'
        },
        {
          title: '',
          key: 'edit',
          slotName: 'editSlot'
        },
        {
          title:'',
          slotName: 'deleteSlot',
          isAlignRight: true
        },
      ]
    },
    subColumns() {
      return [
        {
          title: '',
          key: 'subTitle',
          slotName: 'subNameCol'
        },
        {
          title:'',
          slotName: 'subDeleteCol',
          isAlignRight: true
        },
      ]
    },
  },

  watch: {},

  methods: {
    async getData() {
      this.loading = true;
      try {
        const agglomerations = await api.locations.getRaylwayAgglomerations();
        this.hasData = agglomerations.length > 0;
        if (this.hasData) {
          const sortedAgglomerations = sortArray(agglomerations, 'title');
          this.loading = false;
          return sortedAgglomerations;
        } else {
          this.loading = false;
          return [];
        }
      } catch (err) {
        this.loading = false;
        console.error(err);
      }
    },

    async getLocationsData(row) {
      try {
        const data = await api.locations.getLocationsInAgglomeration(row.item.uuid);

        const allowDeleteReferencePositions = data.filter(item => {
          return item.locationTypeCode === 'REFERENCE_POSITION';
        }).length > 1;

        const allowDeleteRailwayStations = data.filter(item => {
          return item.locationTypeCode === 'RAILWAY_STATION';
        }).length > 1;

        return {
          content: sortArray(data.map(item => {
            item._agglomeration = row.item;
            switch (item?.locationTypeCode) {
              case 'REFERENCE_POSITION': {
                item._allowDelete = allowDeleteReferencePositions;
                break;
              }
              case 'RAILWAY_STATION': {
                item._allowDelete = allowDeleteRailwayStations;
                break;
              }
              default: {
                item._allowDelete = false;
              }
            }
            return item;
          }), 'title'),
          page: null,
          size: data.length,
          totalElements: null,
          totalPages: 1,
          numberOfElements: data.length
        }
      } catch (e) {
        this.$notification({
          type: "system_notification_error",
          message: "Что-то в целом пошло не так. Повторите попытку еще раз. Если проблема повторится, обратитесь в службу поддержки."
        });
        console.error(e);
      }
    },

    onSubTableAction(event) {
      this.agglomerationForModal = event.item;
      this.$refs.raylwayAgglomerationModal.show();
    },

    reloadTable() {
      this.$refs.agglomerationsTable.loadData();
    },

    addNewAglomeration() {
      this.agglomerationForModal = null;
      this.$refs.raylwayAgglomerationModal.show();
    },

    onSelection(row) {
      this.agglomerationForModal = row;
      this.$refs.raylwayAgglomerationModal.show();
    },

    onSubmitModal() {
      this.closeModal();
      this.reloadTable();
    },

    closeModal() {
      this.$refs.raylwayAgglomerationModal.hide();
    },

    deleteAgglomeration(data) {
      this.agglomerationForDelete = data.item;
      this.$refs.deleteRaylwayAgglomerationModal.show();
    },

    async deleteAgglomeration2() {
      if (!this.agglomerationForDelete) {
        console.error('No data for delete');
        this.$refs.deleteRaylwayAgglomerationModal.hide();
        return;
      }

      try {
        const res = await api.locations.deleteAgglomeration(this.agglomerationForDelete.uuid);
        if (res.status === 404) {
          this.$notification({
            type: "system_notification_error",
            message: "Агломерация не найдена"
          });
        } else {
          this.reloadTable();
        }
        this.$refs.deleteRaylwayAgglomerationModal.hide();
      } catch (err) {
        console.error(err);
      }

    },

    deleteLocation(data) {
      this.locationForDelete = data;
      this.$refs.deleteLocationModal.show();
    },

    async deleteLocation2() {
      try {
        const agglomerationUuid = this.locationForDelete._agglomeration.uuid;
        const locationUuid = this.locationForDelete.uuid;
        const res = await api.locations.deleteLocationFromAgglomeration(agglomerationUuid, locationUuid);
        if (res.status === 200) {
          this.reloadTable();
          this.$refs.deleteLocationModal.hide();
        } else {
          throw res
        }
      } catch (err) {
        this.$refs.deleteLocationModal.hide();
        this.$notification({
          type: "system_notification_error",
          message: "Что-то в целом пошло не так. Повторите попытку еще раз. Если проблема повторится, обратитесь в службу поддержки."
        });
        console.error(err);
      }
    },

    formatAuthor(author) {
      return author ? `${author.firstName} ${author.lastName}` : '';
    },

    locationIcon(item) {
      let cls = '';
      switch (item?.locationTypeCode) {
        case 'REFERENCE_POSITION': {
          cls = 'city-sm';
          break;
        }
        case 'RAILWAY_STATION': {
          cls = 'train-sm';
          break;
        }
      }
      return `icon ${cls}`;
    }

  },
}
</script>

<style lang="scss">
@import"~common-components/src/static/css/modal-style.scss";

.sub-table-header__title {
  .icon {
    margin-right: 10px;
  }
}
</style>

<style scoped lang="scss">

.icon-btn {
  color: #D1D2D6;
  cursor: pointer;
  font-size: 20px;

  &:hover {
    color: #0070A6;
  }
}

.modal-content {
  line-height: 1.8em;

  .icon {
    color: #0070A6;
    margin-right: 5px;
  }
}

.sub-table-name {
  .icon {
    color: #0070A6;
    margin-right: 5px;
  }
}

.sub-table-name {
  padding-left: 80px;
}
</style>